import type { LayerPlan } from "./engine/LayerPlan";
import type { MetaByMetaKey } from "./engine/OperationPlan";
import type { ExecutionEventEmitter } from "./interfaces.js";
export interface RequestContext {
    readonly eventEmitter: ExecutionEventEmitter | undefined;
    metaByMetaKey: MetaByMetaKey;
    insideGraphQL: boolean;
}
export interface Bucket {
    layerPlan: LayerPlan;
    size: number;
    noDepsList: readonly undefined[];
    polymorphicPathList: readonly string[];
    store: Map<number, any[]>;
    isComplete: boolean;
    hasErrors: boolean;
    children: {
        [layerPlanId: number]: {
            bucket: Bucket;
            map: Map<number, number | number[]>;
        };
    };
}
//# sourceMappingURL=bucket.d.ts.map