import type { GraphQLInputType, GraphQLType, ListTypeNode, NamedTypeNode, NonNullTypeNode, ValueNode } from "graphql";
import type { OperationPlan } from "./engine/OperationPlan.js";
import { __InputDynamicScalarStep } from "./steps/__inputDynamicScalar.js";
import { __InputObjectStep } from "./steps/__inputObject.js";
import type { ConstantStep } from "./steps/index.js";
import { __InputListStep, __InputStaticLeafStep, __TrackedObjectStep } from "./steps/index.js";
export declare type InputStep = __TrackedObjectStep | __InputListStep | __InputStaticLeafStep | __InputDynamicScalarStep | __InputObjectStep | ConstantStep<undefined>;
export declare function assertInputStep(itemPlan: unknown): asserts itemPlan is InputStep;
export declare function graphqlGetTypeForNode(operationPlan: OperationPlan, node: NamedTypeNode | ListTypeNode | NonNullTypeNode): GraphQLType;
export declare function inputPlan(operationPlan: OperationPlan, inputType: GraphQLInputType, seenTypes: Set<GraphQLInputType>, rawInputValue: ValueNode | undefined, defaultValue?: ValueNode | undefined): InputStep;
//# sourceMappingURL=input.d.ts.map