import type { GraphQLFieldResolver, GraphQLScalarLiteralParser, GraphQLScalarSerializer, GraphQLScalarValueParser, GraphQLSchema } from "graphql";
import type { ArgumentApplyPlanResolver, ArgumentInputPlanResolver, EnumValueApplyPlanResolver, FieldPlanResolver, InputObjectFieldApplyPlanResolver, InputObjectFieldInputPlanResolver, ScalarPlanResolver } from "./interfaces.js";
import type { ExecutableStep } from "./step.js";
export declare type FieldPlans = FieldPlanResolver<any, any, any> | {
    plan?: FieldPlanResolver<any, any, any>;
    subscribePlan?: FieldPlanResolver<any, any, any>;
    resolve?: GraphQLFieldResolver<any, any>;
    subscribe?: GraphQLFieldResolver<any, any>;
    args?: {
        [argName: string]: {
            input?: ArgumentInputPlanResolver;
            apply?: ArgumentApplyPlanResolver;
        };
    };
};
export declare type ObjectPlans = {
    __Step?: {
        new (...args: any[]): ExecutableStep<any>;
    };
} & {
    [fieldName: string]: FieldPlans;
};
export declare type InputObjectPlans = {
    [fieldName: string]: {
        input: InputObjectFieldInputPlanResolver;
        apply: InputObjectFieldApplyPlanResolver;
    };
};
export declare type InterfaceOrUnionPlans = {
    __resolveType?: (o: unknown) => string;
};
export declare type ScalarPlans = {
    serialize?: GraphQLScalarSerializer<any>;
    parseValue?: GraphQLScalarValueParser<any>;
    parseLiteral?: GraphQLScalarLiteralParser<any>;
    plan?: ScalarPlanResolver<any, any>;
};
export declare type EnumPlans = {
    [enumValueName: string]: EnumValueApplyPlanResolver | string | number | boolean | {
        value?: unknown;
        apply?: EnumValueApplyPlanResolver;
    };
};
export interface GrafastPlans {
    [typeName: string]: ObjectPlans | InputObjectPlans | InterfaceOrUnionPlans | ScalarPlans | EnumPlans;
}
export declare function makeGrafastSchema(details: {
    typeDefs: string;
    plans: GrafastPlans;
    enableDeferStream?: boolean;
}): GraphQLSchema;
//# sourceMappingURL=makeGrafastSchema.d.ts.map