import type { Constraint } from "../constraints.js";
import type { ExecutionExtra, GrafastResultsList, GrafastValuesList } from "../interfaces.js";
import { UnbatchedExecutableStep } from "../step.js";
import type { __ValueStep } from "./__value.js";
import type { AccessStep } from "./access.js";
export declare class __TrackedObjectStep<TData = any> extends UnbatchedExecutableStep<TData> {
    static $$export: {
        moduleName: string;
        exportName: string;
    };
    isSyncAndSafe: boolean;
    private readonly value;
    private readonly constraints;
    private readonly path;
    constructor(value: TData | undefined, valuePlan: __ValueStep<TData> | AccessStep<TData>, constraints: Constraint[], path?: Array<string | number>);
    execute(values: [GrafastValuesList<TData>]): GrafastResultsList<TData>;
    unbatchedExecute(extra: ExecutionExtra, v: TData): TData;
    private getValuePlan;
    get<TAttribute extends keyof TData & string>(attrName: TAttribute): __TrackedObjectStep<TData[TAttribute]>;
    at<TIndex extends keyof TData & number>(index: TIndex): __TrackedObjectStep<TData[TIndex]>;
    eval(): TData | undefined;
    evalIs(expectedValue: unknown): boolean;
    evalIsEmpty(): boolean;
    evalHas(key: string): boolean;
    evalLength(): number | null;
    optimize(): import("../step.js").ExecutableStep<any>;
}
//# sourceMappingURL=__trackedObject.d.ts.map