import type { ExecutionExtra, PromiseOrDirect } from "../interfaces.js";
import type { ExecutableStep } from "../step.js";
import { UnbatchedExecutableStep } from "../step.js";
export declare class LambdaStep<TIn, TOut> extends UnbatchedExecutableStep<TOut> {
    private fn;
    static $$export: {
        moduleName: string;
        exportName: string;
    };
    isSyncAndSafe: boolean;
    allowMultipleOptimizations: boolean;
    private planDep;
    constructor($plan: ExecutableStep<TIn> | null | undefined, fn: (value: TIn) => TOut);
    toStringMeta(): any;
    deduplicate(peers: LambdaStep<any, any>[]): LambdaStep<TIn, TOut>[];
    unbatchedExecute(extra: ExecutionExtra, value: TIn): PromiseOrDirect<TOut>;
}
declare function lambda<TIn extends [...any[]], TOut>(plans: {
    [Index in keyof TIn]: ExecutableStep<TIn[Index]>;
}, fn: (value: TIn) => TOut, isSyncAndSafe?: boolean): LambdaStep<TIn, TOut>;
declare function lambda<TIn, TOut>($plan: ExecutableStep<TIn> | null | undefined, fn: (value: TIn) => TOut, isSyncAndSafe?: boolean): LambdaStep<TIn, TOut>;
export { lambda };
//# sourceMappingURL=lambda.d.ts.map