import type { ExecutionExtra } from "../interfaces.js";
import type { ExecutableStep } from "../step.js";
import { UnbatchedExecutableStep } from "../step.js";
declare type UnwrapPlanTuple<TPlanTuple extends readonly ExecutableStep<any>[]> = [
    ...(TPlanTuple extends readonly ExecutableStep<infer U>[] ? readonly U[] : never)
];
export declare class ListStep<TPlanTuple extends readonly ExecutableStep<any>[]> extends UnbatchedExecutableStep<UnwrapPlanTuple<TPlanTuple>> {
    static $$export: {
        moduleName: string;
        exportName: string;
    };
    isSyncAndSafe: boolean;
    allowMultipleOptimizations: boolean;
    constructor(list: readonly [...TPlanTuple]);
    toStringMeta(): string;
    tupleToTuple(results: Array<UnwrapPlanTuple<TPlanTuple>>, tuple: UnwrapPlanTuple<TPlanTuple>): UnwrapPlanTuple<TPlanTuple>;
    execute(values: any[][]): Array<UnwrapPlanTuple<TPlanTuple>>;
    unbatchedExecute(extra: ExecutionExtra, ...values: any[]): UnwrapPlanTuple<TPlanTuple>;
    deduplicate(peers: ListStep<TPlanTuple>[]): ListStep<TPlanTuple>[];
    at<TIndex extends keyof TPlanTuple>(index: TIndex): TPlanTuple[TIndex];
}
export declare function list<TPlanTuple extends ExecutableStep<any>[]>(list: TPlanTuple): ListStep<TPlanTuple>;
export {};
//# sourceMappingURL=list.d.ts.map