import type { __ItemStep } from "../index.js";
import type { ExecutionExtra, GrafastResultsList, GrafastValuesList, PromiseOrDirect } from "../interfaces.js";
import type { ListCapableStep } from "../step.js";
import { ExecutableStep } from "../step.js";
export interface LoadManyOptions<TData, TParams extends Record<string, any>> {
    attributes: ReadonlyArray<keyof TData> | null;
    params: Partial<TParams>;
}
export declare type LoadManyCallback<TSpec, TData, TParams extends Record<string, any>> = {
    (specs: ReadonlyArray<TSpec>, options: LoadManyOptions<TData, TParams>): PromiseOrDirect<ReadonlyArray<ReadonlyArray<TData>>>;
    displayName?: string;
};
export declare function loadManyCallback<TSpec, TData, TParams extends Record<string, any>>(callback: LoadManyCallback<TSpec, TData, TParams>): LoadManyCallback<TSpec, TData, TParams>;
export declare class LoadManySingleRecordStep<TData> extends ExecutableStep<TData> {
    private sourceDescription?;
    static $$export: {
        moduleName: string;
        exportName: string;
    };
    isSyncAndSafe: boolean;
    attributes: Set<keyof TData>;
    constructor($data: ExecutableStep<TData>, sourceDescription?: string | undefined);
    toStringMeta(): string | null;
    get(attr: keyof TData & (string | number)): import("./access.js").AccessStep<unknown>;
    optimize(): ExecutableStep<any>;
    execute([records]: [GrafastValuesList<TData>]): GrafastResultsList<TData>;
}
export declare class LoadManyStep<TSpec, TData, TParams extends Record<string, any>> extends ExecutableStep implements ListCapableStep<TData, LoadManySingleRecordStep<TData>> {
    private load;
    static $$export: {
        moduleName: string;
        exportName: string;
    };
    loadOptions: LoadManyOptions<TData, TParams> | null;
    loadOptionsKey: string;
    attributes: Set<keyof TData>;
    params: Partial<TParams>;
    constructor($spec: ExecutableStep<TSpec>, load: LoadManyCallback<TSpec, TData, TParams>);
    toStringMeta(): string;
    listItem($item: __ItemStep<this>): LoadManySingleRecordStep<TData>;
    setParam<TParamKey extends keyof TParams>(paramKey: TParamKey, value: TParams[TParamKey]): void;
    addAttributes(attributes: Set<keyof TData>): void;
    finalize(): void;
    execute([specs]: [GrafastValuesList<TSpec>], extra: ExecutionExtra): PromiseOrDirect<GrafastResultsList<ReadonlyArray<TData>>>;
}
export declare function loadMany<TSpec, TData, TParams extends Record<string, any>>($spec: ExecutableStep<TSpec>, load: LoadManyCallback<TSpec, TData, TParams>): LoadManyStep<TSpec, TData, TParams>;
//# sourceMappingURL=loadMany.d.ts.map