import type { ExecutionExtra, GrafastResultsList, GrafastValuesList, PromiseOrDirect } from "../interfaces.js";
import { ExecutableStep } from "../step.js";
export interface LoadOneOptions<TData, TParams extends Record<string, any>> {
    attributes: ReadonlyArray<keyof TData> | null;
    params: Partial<TParams>;
}
export declare type LoadOneCallback<TSpec, TData, TParams extends Record<string, any>> = {
    (specs: ReadonlyArray<TSpec>, options: LoadOneOptions<TData, TParams>): PromiseOrDirect<ReadonlyArray<TData>>;
    displayName?: string;
};
export declare function loadOneCallback<TSpec, TData, TParams extends Record<string, any>>(callback: LoadOneCallback<TSpec, TData, TParams>): LoadOneCallback<TSpec, TData, TParams>;
export declare class LoadOneStep<TSpec, TData, TParams extends Record<string, any>> extends ExecutableStep {
    private load;
    static $$export: {
        moduleName: string;
        exportName: string;
    };
    loadOptions: LoadOneOptions<TData, TParams> | null;
    loadOptionsKey: string;
    attributes: Set<keyof TData>;
    params: Partial<TParams>;
    constructor($spec: ExecutableStep<TSpec>, load: LoadOneCallback<TSpec, TData, TParams>);
    toStringMeta(): string;
    get(attr: keyof TData & (string | number)): import("./access.js").AccessStep<unknown>;
    setParam<TParamKey extends keyof TParams>(paramKey: TParamKey, value: TParams[TParamKey]): void;
    finalize(): void;
    execute([specs]: [GrafastValuesList<TSpec>], extra: ExecutionExtra): PromiseOrDirect<GrafastResultsList<TData>>;
}
export declare function loadOne<TSpec, TData, TParams extends Record<string, any>>($spec: ExecutableStep<TSpec>, load: LoadOneCallback<TSpec, TData, TParams>): LoadOneStep<TSpec, TData, TParams>;
//# sourceMappingURL=loadOne.d.ts.map