import type { ExecutionExtra } from "../interfaces.js";
import type { ExecutableStep } from "../step.js";
import { UnbatchedExecutableStep } from "../step.js";
import type { SetterCapableStep } from "./setter.js";
declare type DataFromStep<TStep extends ExecutableStep<any>> = TStep extends ExecutableStep<infer TData> ? TData : never;
declare type DataFromPlans<TPlans extends {
    [key: string]: ExecutableStep<any>;
}> = {
    [key in keyof TPlans]: DataFromStep<TPlans[key]>;
};
declare type Results<TPlans extends {
    [key: string]: ExecutableStep<any>;
}> = Array<[
    Array<DataFromPlans<TPlans>[keyof TPlans]>,
    DataFromPlans<TPlans>
]>;
export interface ObjectPlanMeta<TPlans extends {
    [key: string]: ExecutableStep<any>;
}> {
    results: Results<TPlans>;
}
export declare class ObjectStep<TPlans extends {
    [key: string]: ExecutableStep<any>;
} = {
    [key: string]: ExecutableStep<any>;
}> extends UnbatchedExecutableStep<DataFromPlans<TPlans>> implements SetterCapableStep<TPlans> {
    static $$export: {
        moduleName: string;
        exportName: string;
    };
    isSyncAndSafe: boolean;
    allowMultipleOptimizations: boolean;
    private keys;
    constructor(obj: TPlans);
    set<TKey extends keyof TPlans>(key: TKey, plan: TPlans[TKey]): void;
    getStepForKey<TKey extends keyof TPlans>(key: TKey, allowMissing?: boolean): TKey extends keyof TPlans ? TPlans[TKey] : null;
    toStringMeta(): string;
    tupleToObjectJIT(): (extra: ExecutionExtra, ...tuple: Array<DataFromPlans<TPlans>[keyof TPlans]>) => DataFromPlans<TPlans>;
    finalize(): void;
    execute(values: Array<Array<DataFromPlans<TPlans>[keyof TPlans]>>, extra: ExecutionExtra): Array<DataFromPlans<TPlans>>;
    unbatchedExecute(_extra: ExecutionExtra, ..._values: any[]): any;
    deduplicate(peers: ObjectStep<any>[]): ObjectStep<TPlans>[];
    get<TKey extends keyof TPlans>(key: TKey): TPlans[TKey];
}
export declare function object<TPlans extends {
    [key: string]: ExecutableStep<any>;
}>(obj: TPlans): ObjectStep<TPlans>;
export {};
//# sourceMappingURL=object.d.ts.map